import es
import gamethread
import playerlib
import shelve
import random
import popuplib
import weaponlib
import time
import string
import psyco
from xpints import *
from xpints.environment import *

info = es.AddonInfo()
info.name = '10 Pints Zombie Mod - Zombie Class'
info.version = '1.0.19'
info.basename = '10pintsZombies'
info.url = 'www.thefactoidvoid.com'
info.author = 'Largo Usagi'


psyco.full()
################################################################################
#																			  #
#							 Do not Edit Below This Point                     #
#																			  #
################################################################################
zombiedata = shelve.open(es.getAddonPath('xpints') + '/data/zombiedata.data', writeback=True)
player = xpints.player()
env = environment.env

################################################################################
#						 													  #
#							        CSS Events                                #
#																			  #
################################################################################
def load():
	global zombies
	zombies = zombie()
	
def unload():
	zombiedata.sync()
	
def round_start(ev):
	doshit = 1
	
def player_death(ev):
	zombies.death(ev)
	
def player_spawn(ev):
	zombies.spawn(ev)
	
def round_end(ev):
	zombies.roundEnd(ev)
	
def player_activate(ev):
	zombies.activate(ev)

def player_hurt(ev):
	zombies.playerHurt(ev)

def item_pickup(ev):
	zombies.onPickup(ev)
	
def es_map_start(ev):
	zombies.mapStart(ev)
	random.seed()
	
################################################################################
#						 													  #
#					 	      Global Commands                                 #
#																			  #
################################################################################

def getSteamid(userid):
	userid = int(userid)
	steamid = playerlib.uniqueid(userid, True)
	if 'bot' in steamid:
		steamid = es.getplayername(userid)
	return steamid


################################################################################
#						 													  #
#					 	        Zombie Class                                  #
#																			  #
################################################################################


class zombie(object):
	def __init__(self):
		self.zombieModels = (
			'player/pil/classic',
			'player/pil/corpse/zombiecorpse',
			'player/pil/crispier_v2/crispy')
		self.classic = 0
		self.fast = 0
		self.corpse = 0
		self.poison = 0
		self.crispy = 0
		self.zHpPerRound = int(es.ServerVar('xp_zombie_bonus_health'))
			
	def activate(self,ev):
		userid = ev['userid']
		new_name = es.getplayername(userid)
		steamid = getSteamid(userid)
		if zombiedata.has_key(steamid):
			zombiedata[steamid]['name'] = new_name
		else:
			zombiedata[steamid] = {'speedBonus':0.0,
									'healthBonus':0,
									'damageBonus':0,
									'genetics':0}
			#es.dbgmsg(0,'New User Added to Database')
	
	def roundEnd(self,ev):
		for userid in playerlib.getUseridList('#ct'):
			steamid = getSteamid(userid)
			zombiedata[steamid]['genetics'] += 3
	
	def playerHurt(self, ev):
		attacker = ev['attacker']
		if es.getplayerteam(attacker) == 3:
			self.effects(ev)
	def effects(self, ev):
		attacker = ev['attacker']
		victim = ev['userid']
		steamid = getSteamid(ev['attacker'])
		if ev['weapon'] != "point_hurt":
			zombiedata[steamid]['genetics'] += 1
			damage = zombiedata[steamid]['damageBonus']
			damage += 30
			damage = int(damage / 3)
			player.bleed(victim, damage, attacker,  1, 3)
			#player.damage(victim, 30, attacker)
	def spawn(self, ev):
		team = ev['es_userteam']
		userid = ev['userid']
		if team == '3':
			hp = 75 + (self.zHpPerRound * env.getRoundNum())
			player.addHealth(ev['userid'], hp)
			aplayer = playerlib.getPlayer(userid)
			player.addSpeed(userid, .1)
			aplayer.setArmor(150)
			aplayer.setNightvisionState(1)
			self.specialZombie(userid)
			player.viewOverlay(userid,'effects/tp_eyefx/tpeye3.vmt')
			gamethread.delayed(1,self.hideWeapon,aplayer)
	
	def specialZombie(self,userid):
		aplayer = playerlib.getPlayer(userid)
		rand = random.randint(1,100)
		if rand >= 90:
			player.addSpeed(userid, .5)
			player.addHealth(userid, -100)
			aplayer.set('model', 'player/pil/fast_v5/pil_fast_v5')
			es.tell(userid, "#green", "You have spawned as a fast zombie")
		elif rand >= 80:
			player.setSpeed(userid, 1)
			player.addHealth(userid, +150)
			aplayer.set('model', 'player/pil/poison/poison')
			es.tell(userid, "#green", "You have spawned as a Strong zombie")
		else:
			aplayer.set('model', random.choice(self.zombieModels))
	
	def hideWeapon(self,aplayer):
		list = es.getUseridList()
		if int(aplayer.userid) in list:
			if aplayer.weapon:
				aplayer.setWeaponColor(0, 0, 0, 0)
			else:
				es.dbgmsg(0,'Cant hide weapon, weapon not found')
		else:
			es.dbgmsg(0,'Cant hide weapon, player not found')
	
	def death(self,ev):
		team = ev['es_userteam']
		if team == '3':
			gamethread.delayed(1,player.spawn,ev['userid'])
	
	def onPickup(self, ev):
		try:
			team = ev['es_userteam']
			if team == '3':
				self.zombieStrip(ev['userid'])
		except:
			pass
	
	def zombieStrip(self,userid):
		if int(userid) in es.getUseridList():
			aplayer = playerlib.getPlayer(userid)
			for index, weapon in weaponlib.getWeaponIndexList():#Thanks to Satoon
				if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == aplayer.handle and weapon != 'weapon_knife':
					es.server.cmd('es_xremove %s'%index)
			es.sexec(userid, "use weapon_knife")
		else:
			es.dbgmsg(0,'Cant Strip Player, player not found')
			
	def mapStart(self,ev):
		self.classic = es.precachemodel('models/player/pil/classic.mdl')
		self.fast = es.precachemodel('models/player/pil/fast_v5/pil_fast_v5.mdl')
		self.corpse = es.precachemodel('models/player/pil/corpse/zombiecorpse.mdl')
		self.poison = es.precachemodel('models/player/pil/poison/poison.mdl')
		self.crispy = es.precachemodel('models/player/pil/crispier_v2/crispy.mdl')
		
		zview = es.precachemodel('effects/tp_eyefx/tpeye2.vmt')
		
		modelList = ('.mdl', '.dx80.vtx', '.dx90.vtx', '.phy', '.sw.vtx', '.vvd', '.xbox.vtx')
		materialList = ('.vmt', '.vtf',)
		for ext in modelList:
			es.stringtable('downloadables', 'models/player/pil/classic' + ext)
			es.stringtable('downloadables', 'models/player/pil/fast_v5/pil_fast_v5' + ext)
			es.stringtable('downloadables', 'models/player/pil/corpse/zombiecorpse' + ext)
			es.stringtable('downloadables', 'models/player/pil/poison/poison' + ext)
			es.stringtable('downloadables', 'models/player/pil/crispier_v2/crispy' + ext)



			
##################################################################################################
#EOF
##################################################################################################